// Copyright (c) Microsoft Corporation.  All rights reserved.

//------------------------------------------------------------------------------
// PLEASE NOTE:  Microsoft Corporation (or based on where you live, one of its affiliates) 
// licenses this supplement to you.  You may use it with each validly licensed copy of Microsoft 
// Visual Studio Pre-Release Code-Name "ORCAS" software (the “software”).  You may not use the 
// supplement if you do not have a license for the software.  The license terms for the software 
// apply to your use of this supplement. 
//
// Please note: As this software is distributed in Quebec, Canada, this notice is provided below in French.
// Remarque: Ce logiciel étant distribué au Québec, Canada, les termes de cette licence sont fournis ci-dessous en français.
// REMARQUE:  Microsoft Corporation (ou en fonction du lieu où vous vivez, l’un de ses affiliés) vous 
// accorde une licence pour ce supplément.  Vous pouvez utiliser une copie de ce supplément avec chaque 
// copie concédée sous licence du logiciel Microsoft Visual Studio Pre-Release Code-Name "ORCAS" (le « logiciel »).  
// Vous n’êtes pas autorisé à utiliser ce supplément si vous n’êtes pas titulaire d’une licence pour le logiciel.  
// Les conditions de licence pour le logiciel s’appliquent à l’utilisation de ce supplément.  
//------------------------------------------------------------------------------
using System;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data;
using System.Data.Objects;
using System.Collections.Generic;

using NorthwindLib;

public partial class ProductCategories : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e) {
        if(!IsPostBack) {
            // when initially loading the page, get the list of categories
            // from the database
            using(Northwind db = new Northwind((string)Application["ConnectionString"])) {
                LoadCategoriesGrid(db);
            }
        }
    }

    void LoadCategoriesGrid(Northwind db) {

        //// fetch the list of categories sorted by their names
        ObjectQuery<Category> categories = db.CreateQuery<Category>("Select value c from Categories as c order by c.CategoryName");        
       
        //// bind the results directly to the grid
        gridCategories.DataSource = categories;
        gridCategories.DataBind();
    }

    protected void btnCreateCategory_Click(object sender, EventArgs e) {
        using(Northwind db = new Northwind((string)Application["ConnectionString"])) {

            Category category = new Category();
            category.CategoryName = txtName.Text;
            category.Description = txtDescription.Text;

            // add the category to the context and push the changes to the database
            db.AddObject(category);
            db.SaveChanges();

            // clear the text boxes
            txtName.Text = "";
            txtDescription.Text = "";

            // reload the contents of the grid
            LoadCategoriesGrid(db);
        }
    }
}
